#include	<pic.h>
#include	<string.h>
#include	<stdio.h>
#include	<pic16f6x.h>
#include	<defs.h>
#include	<termo.h>
#include	<10lcd.h>
#include	<delay.h>

__CONFIG	(0x0374);
/* ------------ Date conform pasaportului ---------------
__EEPROM_DATA	(0x82,0x00,0xAA,0x00,0xFA,0x00,0x4A,0x01);
__EEPROM_DATA	(0x95,0x01,0xE4,0x01,0x3A,0x02,0x8A,0x02);
__EEPROM_DATA	(0xD5,0x02,0x20,0x03,0xFF,0xFF,0xFF,0xFF);
__EEPROM_DATA	(0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF);
*/
__EEPROM_DATA	(0x26,0x00,0x6F,0x00,0xBF,0x00,0x09,0x01);
__EEPROM_DATA	(0x4C,0x01,0x96,0x01,0xE0,0x01,0x2A,0x02);
__EEPROM_DATA	(0x74,0x02,0xBE,0x02,0xFF,0xFF,0xFF,0xFF);

unsigned char	i;
UINT	test, ii, adres;
byte	ut;
byte	afis_c;
byte	cnt_f;		// cnt for fast jump to work

void	main(void){

  init_tmr2();
  init_port();
  for(i=5;i!=0;i--) {CLRWDT();delay_ms(200);}
//for(ii=50;ii!=0;ii--){
for(ii=6000;ii!=0;ii--){
	lv_detect();		// detectarea tensiunii joase
	if ((PORTB & 0x0F) != 0x0F){
		if (cnt_f<9) cnt_f++;
		else {
			cnt_f = 25;
			goto	end_wait;}
		}
	else{	cnt_f = 0;}
	delay_ms(200);}
end_wait:

// parametrii initiali
last_key=1;afis_c=0;menu_lev=0;
t_min=eeprom_read(t_min_ad);
t_max=eeprom_read(t_max_ad);
if (eeprom_read(m_lev_ad)==0x03)
	menu_lev=0x03;
set_option();set_lev();

while(1){
// ---------- Lucrul programului -------------------
// ---- Scanarea claviaturii --------------
  lv_detect();
//CLRWDT();
  if (cnt_f!=0){ 
	cnt_f--;
	goto	dont_scan;}

	W = 0x1F & ~PORTB;			// test PORTB
	if (W != 0){
		any_key(W);
		if (do_key == 2){		// up
			val_lev--;
			if(val_lev<min_val_lev) 
				val_lev = max_val_lev;
			}
		else if (do_key == 1){		// dw
			val_lev ++;
			if(val_lev>max_val_lev)	
				val_lev = min_val_lev;
			}
		else if (do_key == 4){		// escape
			set_option();
			if(menu_lev) menu_lev--;
			else	menu_lev = max_lev-1;
			set_lev();
			}
		else if (do_key == 3){		// enter
			set_option();
			if(menu_lev<max_lev)	menu_lev++;
			else	menu_lev = 0;
			set_lev();
			}
		else if (do_key == 5){
			if (menu_lev < lev_ac)	menu_lev=lev_ac;
			else if (menu_lev < (lev_ac+10)){
				uint_to_flash((menu_lev-lev_ac));
				menu_lev++;}
			if (menu_lev > (lev_ac+9)){
				menu_lev=0;
				set_lev();}
			}

		}else{
			c_key = 0;
			asm("clrf _do_key");
			g_pres = 0;
			en_afis = 0;

	}
dont_scan:		//sfirisitul scanarii claviaturii
set_option();
//-----------------------------------------------------
if (do_key){			// --------------------
	en_afis = 1;
	last_key = do_key;}
if (afis_c) afis_c--;
else{	en_afis = 1;
	afis_c = afis_c_c;}	// --------------------
//-----------------------------------------------------
  if (menu_lev >= lev_ac){
  if((afis_c&0x0F)==0x0F)
	ds_conv();		// conversia analogic digitala
  if(adres!=result){
	adres = result;
	en_afis = 1;}
  }
//-----------------------------------------------------
  if (menu_lev==3){
	ds_conv();
	calc_temp();
	if (temp != val_lev)	en_afis=1;
	temp = val_lev;		// val_lev este temperatura
				//curenta si o salvam
	if(temp >= t_max)	termo=0;
	if(temp <= t_min)	termo=1;
	if (eeprom_read(t_min_ad)!=t_min)
		write_flash(t_min_ad,t_min);
	if (eeprom_read(t_max_ad)!=t_max)
		write_flash(t_max_ad,t_max);
	if (eeprom_read(m_lev_ad)!=0x03)
		write_flash(m_lev_ad,0x03);
	}
  else	{
	termo = 0;
	if (eeprom_read(m_lev_ad)!=0x00)
		write_flash(m_lev_ad,0x00);
	}  
//-----------------------------------------------------
if (en_afis){			// afisarea la ecran
  en_afis = 0;
  afis_c = afis_c_c;
  if (menu_lev>max_lev){	// acordarea
	ds_conv();
	printf(" %3d  %4d", (menu_lev-(lev_ac-1))*10, result);
	}
  else{				// --------------------
	if (menu_lev<2){	// selectarea parametrilor
		if (menu_lev == 0) printf(" P0 ");
		else		   printf(" P1 ");
		printf ("- %2d  ", val_lev);}
	else if (menu_lev == 2)	// afisarea param setati
		{printf ("P  %2d - %2d", t_max, t_min);}
	else	printf("%3d %d--%d", val_lev, t_max, t_min);
	}
  }
while(!TMR2IF){}
TMR2IF = 0;
}// ---------- Lucrul programului -------------------
}
// ------------- Peocedura de scanare ------------
void		any_key(unsigned char stat_key){
#define		nr_ps	15	// numarul de ch pe sec
#define		gr_ps	4	// la gradient nr de val
#define		val_gr	(nr_ps/gr_ps)

unsigned char cur_key = 0;
  if (stat_key == 0x01)		cur_key = 1;
  else if (stat_key == 0x02)	cur_key = 2;
  else if (stat_key == 0x04)	cur_key = 3;
  else if (stat_key == 0x08)	cur_key = 4;
  else if (stat_key == 0x10)	cur_key = 5;
  do_key = 0;			// don't exec any key
  if (cur_key == 0){
	g_pres = 0;		// no gr press
	return;}
  c_key ++;
  if (c_key == 1){
	do_key = cur_key;
	return;}
  if (g_pres)	if (c_key > val_gr) c_key = 0;
  if (!g_pres)	if (c_key > nr_ps) {
				c_key = 0;
				g_pres	= 1;}
}
//---------------- END	PROGRAM ----------------
void	init_port(){
	TRISB = 0b00011111;
	VRCON = 0b11101100;
	TRISA = 0b00101110;
	CMCON = 0b00000101;
}
void	init_tmr2(){
	OPTION = 0b00001111;	// WDT enable PS=1:128
	T2CON = 0;
	TMR2IE = 0;
	TMR2IF = 0;
	TMR2 = 0;
	T2CON = 0xFF;	// prescaler 1:16, postscale 1-16
}
// -------- Incarcarea unei date UINT in flash ---
void	uint_to_flash(byte flashadr){
byte	li = flashadr << 1;
		write_flash(li, (result & 0xFF));
	// sfirsitul scrierii jumatatii superioare
		write_flash((li+1), (result>>8));
	// sfirsitul scrierii jumatatii inferioare
}
// ------------- Inscrierea unui B in flash ------------
void	write_flash(byte flashadr, byte flashdata){
	WREN=1;
		EEADR = flashadr;
		EEDATA = flashdata;
		EECON2 = 0x55; EECON2 = 0xAA; WR=1;
		while(WR) continue;
	WREN=0;
}
// -------- Descarcarea unei date UINT din flash ---
UINT	flash_to_uint(byte flashadr){
byte	li = flashadr<<1;
	WW.w.wl = EEPROM_READ(li);
	WW.w.wh = EEPROM_READ(li+1);
return(WW.W16);
}
// -------- Setarea nivelelor ---------------
void	set_lev(void){
if (menu_lev==0){
	max_val_lev = l0_max-1;
	min_val_lev = l0_min;
	val_lev = t_min;
	}
if (menu_lev==1){
	max_val_lev = l0_max;
	min_val_lev = t_min+5;
	val_lev = t_max;
	}
}
// ------------ Setarea optiunilor ----------------
void	set_option(void){
if (menu_lev==0){
	if (val_lev<l0_min)	val_lev = l0_min;
	if (val_lev>l0_max-1)	val_lev = l0_min;
	t_min = val_lev;}
if (menu_lev==1){
	if (val_lev<=t_min)	val_lev = t_min+5;
	if (val_lev>l0_max)	val_lev = t_min+5;
	t_max = val_lev;}
}
// ------------ Calcularea temperaturii -----------
void	calc_temp(void){
byte	li;
UINT	vread;
for(li=0;li<10;li++){
	vread=flash_to_uint(li);
	if (flash_to_uint(li)>result){
		if (li==0){
			val_lev = 10;
			return;}
		vread = (result - flash_to_uint(li-1));
		vread /= (flash_to_uint(li) - flash_to_uint(li-1))/10;
		val_lev = (vread & 0xFF) + ((li+1)*10);
		return;
	}// ------- end	if(vread>result)
	}// ------- end	for(li=0..)
val_lev = 100;	
return;
}
//___________________________________________
// -------- Conversie de 10 biti ------------
void ds_conv(){
  TRISA = 0b00101110;
  CMCON = 0b00000101;
#asm
  clrf	_counter
  clrf	_counter+1
  clrf	_result
  clrf	_result+1
  movf	_TRISA, w
  andlw 0xFE
  movwf _TRISA
loop:
  btfsc	_CMCON, 7	; Is comparator high or low?
  goto complow		; Go the low route
comphigh:
  nop			; necessary to keep timing even
  bcf	_PORTA,0	; PORTA.3 = 0
  incfsz _result,f	; bump counter
  goto	eat2cycles ;
  incf	_result+1,f ;
  goto	endloop ;
complow:
  bsf	_PORTA,0	; Comparator is low
  nop			; necessary to keep timing even
  goto	eat2cycles	; same here
eat2cycles:
  goto	endloop		; eat 2 more cycles
endloop:
  incfsz _counter,f	; Count this lap through the loop. (10-l,10-h)
  goto	next5cycles
  incf	_counter+1,f ;
  movf	_counter+1,w ;
  andlw	0x04		; Are we done? (We're done when bit2 of
  btfsc	_STATUS, 2	; the high order byte overflows to 1).
  goto loop
  goto exit
next5cycles:
  nop
  nop
  nop
  goto	loop
exit:
  movf	_TRISA, w
  iorlw 0x01
  movwf _TRISA
#endasm
  RA0 = 0;
}
// ------------ Detect lv -------------------------
void	lv_detect(void){
  TRISA = 0b00101111;
  CMCON = 0b00001010;
  if (C1OUT){
	RA4 = 1;
	termo = 0;
	while(1); }
  else	{RA4 = 0;}	
  CLRWDT();
}
